<%-- $Id: edit_sample.jsp 6947 2015-09-08 12:30:31Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.NameableConverter"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.SAMPLE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Sample sample = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	Item parentType = null;
	String name = null;
	boolean lockEventProperties = false;

	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	boolean readCurrentBioSource = true;
	BioSource currentBioSource = null;
	ItemQuery<Sample> samplesQuery = null;	
	boolean readCurrentBioWell = true;
	BioWell currentBioWell = null;
	boolean lockedWell = false;
	boolean readCurrentBioPlate = true;
	BioPlate currentBioPlate = null;
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	if (itemId == 0)
	{
		title = "Create sample";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		int bioSourceId = Values.getInt(request.getParameter("biosource_id"));
		int sampleId = Values.getInt(request.getParameter("sample_id"));
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		if (bioSourceId != 0)
		{
			currentBioSource = BioSource.getById(dc, bioSourceId);
			parentType = Item.BIOSOURCE;
			name = currentBioSource.getName() + ".s" + (currentBioSource.countSamples() + 1);
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, currentBioSource, Item.SAMPLE);
			}
		}
		else if (sampleId != 0)
		{
			parentType = Item.SAMPLE;
			Sample s = Sample.getById(dc, sampleId);
			name = s.getName() + ".s" + (s.countSamples()+1);
			samplesQuery = Sample.getQuery();
			samplesQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(sampleId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, s, Item.SAMPLE);
			}
		}
		else if (Values.getBoolean(request.getParameter("pooled")))
		{		
			parentType = Item.SAMPLE;
			name = Values.getString(cc.getPropertyValue("name"), "New pooled sample");
			samplesQuery = Sample.getQuery();
			samplesQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			samplesQuery.setParameter("selected", cc.getSelected(), Type.INT);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New sample");
		}
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
		eventDate = (Date)cc.getPropertyObject("creationEvent.eventDate");
	}
	else
	{
		sample = Sample.getById(dc, itemId);
		sample.checkPermission(Permission.WRITE);
		cc.setObject("item", sample);
		title = "Edit sample -- " + HTML.encodeTags(sample.getName());
	
		creationEvent = sample.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		parentType = sample.getParentType();
		name = sample.getName();
		lockEventProperties = !creationEvent.hasPermission(Permission.WRITE);
		
		try
		{
			currentSubtype = sample.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}

		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
	
		try
		{
			if (parentType == Item.BIOSOURCE)
			{
				currentBioSource = (BioSource)sample.getParent();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioSource = false;
		}
		
		try
		{
			currentBioWell = sample.getBioWell();
			lockedWell = sample.isLockedInWell();
			if (currentBioWell != null)
			{
				currentBioPlate = currentBioWell.getPlate();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioWell = false;
			readCurrentBioPlate = false;
		}
	
		// Query to retrieve parent samples
		if (parentType == Item.SAMPLE)
		{
			samplesQuery = (ItemQuery<Sample>)creationEvent.getSources();
		}
	}
	
	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		ItemSubtype protocolSubtype = currentSubtype == null ? null : currentSubtype.getRelatedSubtype(Item.PROTOCOL);
		if (protocolSubtype == null) protocolSubtype = ItemSubtype.getById(dc, SystemItems.getId(Protocol.SAMPLING));
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItems(dc, protocolSubtype, false);
	}
	
	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<BioSource> recentBioSources = (List<BioSource>)cc.getRecent(dc, Item.BIOSOURCE);
	List<BioPlate> recentBioPlates = (List<BioPlate>)cc.getRecent(dc, Item.BIOPLATE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	JSONObject jsonBioWell = null;
	if (currentBioWell != null)
	{
		jsonBioWell = new JSONObject();
		jsonBioWell.put("id", currentBioWell.getId());
		jsonBioWell.put("location", currentBioWell.getCoordinate());
	}
	
	JSONObject jsonSamples = new JSONObject();
	jsonSamples.put("itemType", "SAMPLE");
	if (samplesQuery != null)
	{
		final BioMaterialEvent event = creationEvent;
		jsonSamples.put("items", JsonUtil.toArray(samplesQuery.iterate(dc), new NameableConverter<Sample>()
		{
			protected void setMore(JSONObject json, Sample s)
			{
				Float usedQuantity = event == null ? null : event.getUsedQuantity(s);
				json.put("name", s.getName() + (usedQuantity == null ? " [-]" : " [" +  usedQuantity + " µg]"));
				json.put("value", usedQuantity);
			}
		}));
	}

	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), sample);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,subtypes.js,~samples.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="sample">
		<input type="hidden" name="cmd" value="UpdateItem">

		<div id="page-data" class="datacontainer"
			data-sampling-protocoltype-id="<%=SystemItems.getId(Protocol.SAMPLING)%>"
			data-sample-type="<%=Item.SAMPLE.getValue()%>"
			<%
			if (jsonBioWell != null)
			{
				%>
				data-biowell="<%=HTML.encodeTags(jsonBioWell.toJSONString()) %>"
				<%
			}
			%>
		></div>

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol" 
			position="bottom" remember="<%=sample != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Sample" helpid="sample.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=sample == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=Sample.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id" id="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && sample != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input class="text" type="text" name="external_id" 
					value="<%=HTML.encodeTags(sample == null ? Values.getString(cc.getPropertyValue("externalId"), "") : sample.getExternalId())%>" 
					maxlength="<%=Sample.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Original quantity</th>
				<td><input class="text" type="text" name="original_quantity" id="original_quantity" style="width: 15em;"
					value="<%=Values.formatNumber(sample == null ? Values.getFloat(cc.getPropertyValue("originalQuantity"), null): sample.getOriginalQuantity(), -1)%>" size="12" 
					maxlength="10"> (µg)</td>
				<td></td>
			</tr>
			<tr>
				<th>Created</th>
				<td>
					<table>
					<tr>
					<td>
						<input class="text" style="width: 15em;" type="text" name="event_date" id="event_date"
							<%=lockEventProperties ? "disabled" : ""%>
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:calendar textarea="event_date" title="Created" 
							disabled="<%=lockEventProperties%>"
						/>
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=sample == null%>"
						disabled="<%=lockEventProperties %>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Bioplate</th>
				<td>
					<base:select 
						id="bioplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioPlate%>"
						denied="<%=!readCurrentBioPlate%>"
						recent="<%=recentBioPlates%>"
						newitem="<%=sample == null%>"
						disabled="<%=lockedWell%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">- well</th>
				<td>
					<base:select 
						id="biowell_id"
						clazz="selectionlist"
						required="false"						
						current="<%=null %>"
						denied="<%=!readCurrentBioWell%>"
						newitem="<%=sample == null%>"
						disabled="<%=lockedWell%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(sample == null ? cc.getPropertyValue("description") : sample.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="parents" title="Parents" helpid="sample.parents" >
			<table class="fullform input100">
			<tr>
				<th>Parent type</th>
				<td>
					<input type="radio" name="parentType" id="parentType.biosource" 
						value="BIOSOURCE" <%=parentType != Item.SAMPLE ? "checked" : ""%>
						><label for="parentType.biosource">Biosource</label>
					<input type="radio" name="parentType" id="parentType.sample" 
						value="SAMPLE" <%=parentType == Item.SAMPLE ? "checked" : ""%>
						><label for="parentType.sample">Sample</label>
				</td>
			</tr>
			<tr>
				<th>Biosource</th>
				<td>
					<base:select 
						id="biosource_id"
						clazz="selectionlist"
						buttonstyle="width: 14em;"
						buttonicon="add.png"
						buttontitle="Select biosource&hellip;"
						buttonclass="leftaligned basicbutton button"
						required="false"
						current="<%=currentBioSource%>"
						denied="<%=!readCurrentBioSource%>"
						recent="<%=recentBioSources%>"
						selectrecent="false"
						newitem="<%=sample == null%>"
					/>
				</td>
			</tr>
			<tr class="big">
				<th>Samples</th>
				<td>
					<div class="selectionlist">
					<table>
					<tr>
						<td>
						<select name="samples" id="samples"
							class="auto-init"
							data-auto-init="link-container"
							data-initial-items="[<%=HTML.encodeTags(jsonSamples.toJSONString()) %>]"
							data-initial-action="<%=sample == null ? 1 : 0 %>"
							size="15" multiple>
						</select>
					</td>
					<td style="vertical-align: top;">
						<base:buttongroup vertical="true">
							<base:button 
								id="btnAddSamples"
								subclass="leftaligned"
								style="width: 14em;"
								title="Add&nbsp;samples&hellip;" 
								tooltip="Add samples"
							/>
							<base:button 
								subclass="leftaligned auto-init"
								data-auto-init="remove-link"
								data-list-id="samples"
								style="width: 14em;"
								title="Remove" 
								tooltip="Remove the selected samples"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			<tr>
				<th class="subprompt">- used quantity</th>
				<td>
					<input class="text" style="width: 15em;" type="text" 
						name="used_quantity" id="used_quantity" value=""
						 maxlength="10"> (µg)
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
