/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var JepPlugins = function()
{
	var jepPlugins = {};
	
	/**
		Initialize the page.
	*/
	jepPlugins.initPage = function()
	{
		Buttons.addClickHandler('btnShowError', jepPlugins.showErrorList);
		Buttons.addClickHandler('btnHideError', jepPlugins.hideErrorList);
		Buttons.addClickHandler('close', jepPlugins.cancelWizard);
	}
	
	/**
		Cancel export wizard.
	*/
	jepPlugins.cancelWizard = function()
	{
		location.href = 'index.jsp?ID='+App.getSessionId()+'&cmd=CancelWizard';
	}
	
	jepPlugins.hideErrorList = function()
	{
		Doc.hide('errorlist');
		Doc.show('showerrorlist');
	}
	
	jepPlugins.showErrorList = function()
	{
		Doc.show('errorlist');
		Doc.hide('showerrorlist');
	}

	jepPlugins.cancelWizard = function()
	{
		location.href = 'index.jsp?ID='+App.getSessionId()+'&cmd=CancelWizard';
	}

	jepPlugins.presetOnChange = function(event)
	{
		var formula = Doc.element(Data.get(event.currentTarget, 'formula-id'));
		formula.value = event.currentTarget.value;
		event.currentTarget.selectedIndex = 0;
	}
	
	jepPlugins.openExpressionBuilder = function(event)
	{
		var formulaField = Doc.element(Data.get(event.currentTarget, 'formula-id'));
		
		if (!formulaField.disabled)
		{
			var title = Data.get(event.currentTarget, 'title');
			var formulaType = Data.get(event.currentTarget, 'formula-type');
			var rawDataType = Data.get(event.currentTarget, 'raw-data-type');
			var channels = Data.int(event.currentTarget, 'channels');
			var bioAssaySetId = Data.int(event.currentTarget, 'bioassayset');
			
			Dialogs.openExpressionBuilder(formulaField, title, formulaType, rawDataType, channels, bioAssaySetId);
		}
	}

	
	return jepPlugins;
}();

Doc.onLoad(JepPlugins.initPage);

